// Experiment with STL containers, iterators, and algorithms
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

int main () {
  vector<int> myVector;
  vector<int>::iterator left, right;
  set<int> mySet;
  set<int>::iterator setIter1, setIter2;

  // set some content in the vector:
  for (int i=0; i<10; i++) {
    int value = rand()%100;
    myVector.push_back(value);
    mySet.insert(value);
  } // end for
 
  cout << "vector values: ";
  for (left = myVector.begin(); left < myVector.end(); left++) {
    cout << *left << " ";
  } // end for
  cout << endl << endl;

  cout << "set values: ";
  for (setIter1 = mySet.begin(); setIter1 != mySet.end(); setIter1++) {
    cout << *setIter1 << " ";
  } // end for
  cout << endl << endl;

  left = myVector.begin();
  right = myVector.end();
  left++;
  left++;
  right--;
  sort(left, right);

  cout << "vector values after sort: ";
  for (left = myVector.begin(); left < myVector.end(); left++) {
    cout << *left << " ";
  } // end for
  cout << endl;

  return 0;
} // end main
